#include "scene.h"
#include <iostream.h>
#include <fstream.h>
#include <float.h>
#include <string.h>
#include "FL/gl.h"

#include "m33.h"

Scene *scene;

Scene::Scene() {

  fb = new FrameBuffer(20, 40, 640, 480);
  fb->label("SW rendering");
  ui = new GraphAppUI();
  ui->GraphAppW->position(800, 40);
  Show();
  Redraw();

}

void Scene::Show() {

  if (fb)
    fb->show();
  if (ui)
    ui->GraphAppW->show();

}


void Scene::Redraw() {

  if (fb) {
    Render();
    fb->redraw();
  }

}


void Scene::DBG() {

  M33 m;
  cerr << m;
  m[1][2] = 13.7f;
  cerr << m;
  return;

  V3 v(3.0f, 4.0f, 5.0f);
  V3 v2(1.0f, -1.0f, 3.0f);
  cerr << "v " << v << endl;
  cerr << "v2 " << v2 << endl;
  cerr << "v+v2 " << v+v2 << endl;
  cerr << "v-v2 " << v-v2 << endl;
  cerr << "v*v2 " << v*v2 << endl;
  cerr << "v length " << v.Length() << endl;
  cerr << "v normalized " << v.Normalized() << endl;

  return;

  if (fb) {
    fb->Clear(0xFFFFFFFF);
    float uf = 150.0f;
    float vf = 200.0f;
    int size = 53;
    fb->DrawPointSquare(uf, vf, size, 0xFF00FF00);
    fb->DrawPointDiagonalCross(uf, vf, size, 0xFF0000FF);
    float u1f = 170.4f;
    float v1f = 301.9f;
    fb->DrawSegment(uf, vf, u1f, v1f, 0xFFFF0000);
    unsigned int colors[2] = {0xFF00FF00, 0xFF0000FF};
    fb->MakeChecker(30, colors);
  }
  Redraw();

}

void Scene::Render() {

  if (!fb)
    return;

  unsigned int bgrColor = 0xFFFFFFFF;
  fb->Clear(bgrColor);

  float hfov = 60.0f;
  PHC phc(fb->w, fb->h, hfov);
  V3 verts[8];
  float cubeSide = 20.0f;
  verts[0] = V3(-cubeSide, +cubeSide, -100.0f);
  verts[1] = V3(-cubeSide, -cubeSide, -100.0f);
  verts[2] = V3(+cubeSide, -cubeSide, -100.0f);
  verts[3] = V3(+cubeSide, +cubeSide, -100.0f);
  verts[4+0] = V3(-cubeSide, +cubeSide, -100.0f-2*cubeSide);
  verts[4+1] = V3(-cubeSide, -cubeSide, -100.0f-2*cubeSide);
  verts[4+2] = V3(+cubeSide, -cubeSide, -100.0f-2*cubeSide);
  verts[4+3] = V3(+cubeSide, +cubeSide, -100.0f-2*cubeSide);
  unsigned int color = 0xFF0088AA;
  unsigned int color2 = 0xFF0000FF;
  for (int i = 0; i < 4; i++) {
    fb->DrawSegment3D(verts[i], verts[(i+1)%4], phc, color);
    fb->DrawSegment3D(verts[i+4], verts[(i+1)%4+4], phc, color2);
  }

}

void Scene::MouseMove(int u, int v) {

  return;

  if (!fb)
    return;
  fb->DrawPointSquare(.5f+(float)u, .5f+(float)v, 5, 0xFF000000);
  Redraw();

}